## kdiagram2 2.8.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.12)

project( kdiagram )

set(KF5_MIN_VERSION "5.60.0")
find_package(ECM ${KF5_MIN_VERSION} REQUIRED NO_MODULE)

set(CMAKE_MODULE_PATH ${ECM_MODULE_PATH} ${ECM_KDE_MODULE_DIR})

include(KDEInstallDirs)
include(KDEFrameworkCompilerSettings NO_POLICY_SCOPE)
include(KDECMakeSettings)

include(FeatureSummary)
include(GenerateExportHeader)

include(ECMGenerateHeaders)
include(ECMSetupVersion)
include(ECMPackageConfigHelpers)
include(ECMGeneratePriFile)
include(ECMPoQmTools)
include(ECMAddTests)
set(QT_REQUIRED_VERSION "5.12.0")

include(CMakeDependentOption)

set(HAS_ECMAddQch TRUE)
include(ECMAddQch)

cmake_dependent_option(BUILD_QCH
    "Build API documentation in QCH format (for e.g. Qt Assistant, Qt Creator & KDevelop)" OFF
    "HAS_ECMAddQch" OFF
)
add_feature_info(QCH ${BUILD_QCH} "API documentation in QCH format (for e.g. Qt Assistant, Qt Creator & KDevelop)")

find_package(Qt5 ${QT_REQUIRED_VERSION} REQUIRED NO_MODULE
    COMPONENTS
    PrintSupport
    Svg
    Widgets
)
if(BUILD_TESTING)
    find_package(Qt5Test QUIET)
    if (NOT Qt5Test_FOUND)
        message(STATUS "Qt5Test not found, unit tests will not be built.")
    endif()
endif()

find_package(Qt5Sql QUIET)
if (NOT Qt5Sql_FOUND)
    message(STATUS "Qt5Sql not found, examples with SQL will not be built.")
endif()

# We want users of kdiagram libs to be able to use the lib without interference with Qt-specific keywords, e.g. "signals" that collides with Boost's Signals
add_definitions(
    -DQT_NO_KEYWORDS
    -Demit=
)
add_definitions(
    -DQT_NO_STL
    -DQT_FATAL_ASSERT
    -DUSE_EXCEPTIONS
)

# TODO: port from .pro
#  NOMINMAX avoids conflicting definitions of min and max
#  _USE_MATH_DEFINES makes M_PI defined
# win32 {
# !win32-g++ {
#     DEFINES += NOMINMAX _USE_MATH_DEFINES
#     QMAKE_CXXFLAGS += /GR /EHsc /wd4251
# }
# }

# TODO: port g++.pri to cmake and check what is still needed


if (IS_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/po")
    ecm_install_po_files_as_qm(po)
endif()

add_subdirectory( src )

if(BUILD_TESTING)
    add_subdirectory( examples )
    add_subdirectory( tests )

    if(Qt5Test_FOUND)
        add_subdirectory( qtests )
    endif()
endif()

feature_summary(WHAT ALL INCLUDE_QUIET_PACKAGES FATAL_ON_MISSING_REQUIRED_PACKAGES)

=== src/CMakeLists.txt ===
include(ECMOptionalAddSubdirectory)
ecm_optional_add_subdirectory( KChart )
ecm_optional_add_subdirectory( KGantt )

=== examples/Gantt/CMakeLists.txt ===
remove_definitions(
    -DQT_NO_KEYWORDS
    -DQT_NO_SIGNALS_SLOTS_KEYWORDS
    -DQT_NO_CAST_FROM_ASCII
)

add_subdirectory(legend_example)
add_subdirectory(project)
add_subdirectory(palette)
add_subdirectory(printing)

=== examples/Plane/CMakeLists.txt ===
add_subdirectory(AdjustedBoundaries)
add_subdirectory(OverlayedPlanes)

=== examples/Plotter/CMakeLists.txt ===
add_subdirectory(Advanced)
add_subdirectory(BigDataset)
add_subdirectory(BubbleChart)
add_subdirectory(Isometric)
add_subdirectory(Logarithmic)
add_subdirectory(Simple)
add_subdirectory(Timeline)

=== examples/TernaryCharts/CMakeLists.txt ===
add_subdirectory(Advanced)

=== examples/tools/CMakeLists.txt ===
set( testtools_LIB_SRCS
    TableModel.cpp
)

add_library(testtools SHARED ${testtools_LIB_SRCS})

generate_export_header( testtools )

target_link_libraries(testtools LINK_PRIVATE
    Qt5::Core
)

=== qtests/AttributesModel/CMakeLists.txt ===
set(TestKChartAttributesModel_SRCS
    main.cpp
)

qt5_add_resources(TestKChartAttributesModel_SRCS
    Data.qrc
)

ecm_add_test(
    ${TestKChartAttributesModel_SRCS}
    TEST_NAME TestKChartAttributesModel
    LINK_LIBRARIES testtools KChart Qt5::Widgets Qt5::Test
)

=== qtests/CartesianPlanes/CMakeLists.txt ===
set(TestCartesianPlanes_SRCS
    main.cpp
)

qt5_add_resources(TestCartesianPlanes_SRCS
    Data.qrc
)

ecm_add_test(
    ${TestCartesianPlanes_SRCS}
    TEST_NAME TestCartesianPlanes
    LINK_LIBRARIES testtools KChart Qt5::Widgets Qt5::Test
)

=== qtests/DrawIntoPainter/CMakeLists.txt ===
set(TestDrawIntoPainter_SRCS
    framewidget.cpp
    mainwindow.cpp
    main.cpp
)

qt5_wrap_ui(TestDrawIntoPainter_SRCS
    mainwindow.ui
)

qt5_add_resources(TestDrawIntoPainter_SRCS
    DrawIntoPainter.qrc
)

ecm_add_test(
    ${TestDrawIntoPainter_SRCS}
    TEST_NAME TestDrawIntoPainter
    LINK_LIBRARIES testtools KChart Qt5::Widgets Qt5::Test
)

set_property(TEST TestDrawIntoPainter PROPERTY TIMEOUT 600)

=== qtests/LineDiagrams/CMakeLists.txt ===
set(TestLineDiagrams_SRCS
    main.cpp
)

qt5_add_resources(TestLineDiagrams_SRCS
    Data.qrc
)

ecm_add_test(
    ${TestLineDiagrams_SRCS}
    TEST_NAME TestLineDiagrams
    LINK_LIBRARIES testtools KChart Qt5::Widgets Qt5::Test
)

=== qtests/ParamVsParam/CMakeLists.txt ===
set(TestParamVsParam_SRCS
    ModelParamVsParam.cpp
    ModelParamVsParamPlot.cpp
    mainwindow.cpp
    main.cpp
)

ecm_add_test(
    ${TestParamVsParam_SRCS}
    TEST_NAME TestParamVsParam
    LINK_LIBRARIES testtools KChart Qt5::Widgets Qt5::Test
)

=== debian/changelog ===
kdiagram2 (2.8.0-5) unstable; urgency=medium

  [ Patrick Franz ]
  * Team upload.
  * Add patch to ensure compatibility with both CMake 3.36 and CMake 4
    (Closes: #1113072).

 -- Patrick Franz <deltaone@debian.org>  Sat, 06 Sep 2025 01:01:40 +0200

kdiagram2 (2.8.0-4) unstable; urgency=medium

  * Make sure to always build the tests, as building them exposes certain
    symbols in the libraries:
    - pass -DBUILD_TESTING=ON to cmake
  * Remove the explicit as-needed linking, as it is done by binutils now.
  * Mark the xauth, and xvfb build dependencies as <!nocheck>, as they are
    needed only when running the test suite.

 -- Pino Toscano <pino@debian.org>  Mon, 07 Apr 2025 08:34:28 +0200

kdiagram2 (2.8.0-3) unstable; urgency=medium

  [ Patrick Franz ]
  * Team upload.
  * Source-only upload to unstable so the package can migrate to
    testing.

 -- Patrick Franz <deltaone@debian.org>  Tue, 01 Apr 2025 20:03:25 +0200

kdiagram2 (2.8.0-2) unstable; urgency=medium

  * Team upload.

  [ Pino Toscano ]
  * Introduce kdiagram version 2.x as separate source, as it is the last
    version based on Qt 5 and some sources still need it:
    - rename the source to kdiagram2
    - rename the binary package libkchart-dev to libkchart2-dev, adding
      a conflict for the old name
    - rename the binary package libkgantt-dev to libkgantt2-dev, adding
      a conflict for the old name
    - the translation files conflict with newer version of kdiagram, so:
      - drop the libkchart2-l10n, and libkgantt2-l10n binary packages
      - do not ship the translations at all
      - recommend the libkchart-l10n, and libkgantt-l10n binary packages
        instead (not optimal, still better than nothing)
  * Replace the watch file with a comment, as there will be no more versions
    for Qt 5.
  * Update Vcs-* fields to point to the '2.x' packaging branch for this source.
  * Bump Standards-Version to 4.7.0, no changes required.
  * Drop the dh_auto_test-indep override, as there are no more arch:all binary
    packages.

  [ Patrick Franz ]
  * Update d/copyright.
  * Bump Standards-Version to 4.7.2 (no changes needed).
  * Update upstream homepage.

 -- Patrick Franz <deltaone@debian.org>  Mon, 31 Mar 2025 22:42:02 +0200

kdiagram (2.8.0-1) unstable; urgency=medium

  * New upstream release.
  * Update the build dependencies according to the upstream build system:
    - bump qtbase5-dev to 5.12.0
    - bump extra-cmake-modules to 5.60.0
  * Update symbols files.

 -- Pino Toscano <pino@debian.org>  Sun, 17 Jan 2021 12:45:36 +0100

kdiagram (2.7.0-2) unstable; urgency=medium

  * Bump the debhelper compatibility to 13:
    - switch the debhelper-compat build dependency to 13
    - stop passing --fail-missing to dh_missing, as it is the default now
  * Bump Standards-Version to 4.5.1, no changes required.
  * Add Rules-Requires-Root: no.
  * Use correct machine-readable copyright file URI.
  * Update symbols files. (Closes: #975186)

 -- Pino Toscano <pino@debian.org>  Sun, 22 Nov 2020 14:47:59 +0100

kdiagram (2.7.0-1) unstable; urgency=medium

  * New upstream release.
  * Update the patches:
    - test-increased-timeout.diff: drop, fixed upstream
  * Update symbols files.

 -- Pino Toscano <pino@debian.org>  Tue, 21 Apr 2020 10:00:12 +0200

kdiagram (2.6.3-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.

 -- Pino Toscano <pino@debian.org>  Mon, 13 Apr 2020 00:28:08 +0200

kdiagram (2.6.2-4) unstable; urgency=medium

  * Update test-increased-timeout.diff to increase the timeouts to 60 minutes,
    hopefully it should be enough also for really slow architectures...

 -- Pino Toscano <pino@debian.org>  Sun, 29 Mar 2020 18:37:26 +0200

kdiagram (2.6.2-3) unstable; urgency=medium

  * Update test-increased-timeout.diff to increase also the QtTest default
    timeout to 30 minutes.

 -- Pino Toscano <pino@debian.org>  Sun, 29 Mar 2020 11:51:38 +0200

kdiagram (2.6.2-2) unstable; urgency=medium

  * Update test-increased-timeout.diff to use a better (and hopefully working)
    API for changing the test timeout.

 -- Pino Toscano <pino@debian.org>  Sun, 29 Mar 2020 00:24:36 +0100

kdiagram (2.6.2-1) unstable; urgency=medium

  * New upstream release.
  * Add the configuration for the CI on salsa.
  * Update Vcs-* fields.
  * Update symbols files.
  * Increase the timeout for TestDrawIntoPainter to 30 minutes, so even slower
    architectures should run it successfully. (Closes: 947492)
  * Bump the debhelper compatibility to 12:
    - switch the debhelper build dependency to debhelper-compat 12
    - remove debian/compat
  * Bump Standards-Version to 4.5.0, no changes required.

 -- Pino Toscano <pino@debian.org>  Sat, 28 Mar 2020 23:21:54 +0100

kdiagram (2.6.1-1) unstable; urgency=medium

  * New upstream release.
  * Update path in watch file.
  * Update symbols files from logs of buildds, and removing private symbols
    no more exposed.
  * Adopt under the Debian KDE Extras Team wing, with myself as Uploader.
    (Closes: #874391)
  * Switch Vcs-* fields to salsa.debian.org.
  * Bump Standards-Version to 4.1.4, no changes required.
  * Pass --fail-missing to dh_missing.

 -- Pino Toscano <pino@debian.org>  Sat, 21 Apr 2018 07:42:07 +0200

kdiagram (2.6.0-3) unstable; urgency=medium

  * QA upload.
  * Add symbols files, and thus remove the dh_makeshlibs -V invocation.
  * Tweak install files to catch potential SONAME bumps.
  * Simplify watch file, and switch it to https.
  * Use https for Format in copyright.
  * Bump Standards-Version to 4.1.3, no changes required.
  * Bump the debhelper compatibility to 11:
    - bump the debhelper build dependency to 11~
    - bump compat to 11

 -- Pino Toscano <pino@debian.org>  Thu, 22 Mar 2018 09:10:54 +0100

kdiagram (2.6.0-2) unstable; urgency=medium

  * QA upload.
  * Set maintainer to the QA group.
  * Build-Depend on qttools5-dev. (Closes: #881079)

 -- Adam Borowski <kilobyte@angband.pl>  Wed, 15 Nov 2017 05:07:55 +0100



=== debian/control ===
Source: kdiagram2
Section: libs
Priority: optional
Maintainer: Debian KDE Extras Team <pkg-kde-extras@lists.alioth.debian.org>
Uploaders: Pino Toscano <pino@debian.org>,
Build-Depends:
 cmake (>= 3.10.0~),
 debhelper-compat (= 13),
 extra-cmake-modules (>= 5.60.0~),
 libqt5svg5-dev,
 qtbase5-dev (>= 5.12.0~),
 qttools5-dev,
 qttools5-dev-tools,
 xauth <!nocheck>,
 xvfb <!nocheck>,
Standards-Version: 4.7.2
Rules-Requires-Root: no
Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/kdiagram.git -b 2.x
Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/kdiagram/-/tree/2.x
Homepage: https://invent.kde.org/graphics/kdiagram

Package: libkchart2-dev
Architecture: any
Section: libdevel
Multi-Arch: same
Depends:
 libkchart2 (= ${binary:Version}),
 libqt5svg5-dev,
 qtbase5-dev (>= 5.2),
 ${misc:Depends}
Conflicts: libkchart-dev
Description: library for creating business charts (development files)
 KD Charts provides an implementation of the ODF Chart specification. It
 supports stock charts, box charts, and whisker charts and allows one to
 integrate these charts in Qt-based applications.
 .
 This package contains the development files.

Package: libkchart2
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Recommends:
 libkchart-l10n
Description: library for creating business charts (shared library)
 KD Charts provides an implementation of the ODF Chart specification. It
 supports stock charts, box charts, and whisker charts and allows one to
 integrate these charts in Qt-based applications.
 .
 This package contains the shared library.

Package: libkgantt2-dev
Architecture: any
Section: libdevel
Multi-Arch: same
Depends:
 libkgantt2 (= ${binary:Version}),
 qtbase5-dev (>= 5.2),
 ${misc:Depends}
Conflicts: libkgantt-dev
Description: library for creating Gantt diagrams (development files)
 Gantt charts are a bar charts that illustrate project schedules. KD Gantt
 provides a module for implementing ODF Gantt charts in Qt-based applications.
 .
 This package contains the development files.

Package: libkgantt2
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Recommends:
 libkgantt2-l10n
Description: library for creating Gantt diagrams (shared library)
 Gantt charts are a bar charts that illustrate project schedules. KD Gantt
 provides a module for implementing ODF Gantt charts in Qt-based applications.
 .
 This package contains the shared library.

=== debian/rules ===
#! /usr/bin/make -f

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DBUILD_TESTING=ON

override_dh_auto_test-arch:
	xvfb-run -a dh_auto_test -a

execute_after_dh_auto_install:
	# the translations conflict with newer version of kdiagram,
	# so do not ship them
	rm -rf debian/tmp/usr/share/locale/

=== debian/watch ===
# no more versions for qt5
